#ifndef __AF_POLY_POLYN__
#define __AF_POLY_POLYN__

#include "roots.h"

struct Polyn {
	static float STEP;
	Polyn() {}
	virtual ~Polyn() {}
	virtual float valueAt(float x) = 0;
	virtual bool isRoot(float root) = 0;
	virtual Roots *getRoots() = 0;
	static Polyn *make(int level, float *koef);
};

#include "polyn_z.h"
#include "polyn_st.h"
#include "polyn_nd.h"
#include "polyn_m.h"

#endif //__AF_POLY_POLYN__
