#include "polyn_nd.h"
#include <math.h>

PolynNd::PolynNd() {
	a = 1;
	b = c = 0;
}

PolynNd::PolynNd(float a, float b, float c) {
	if (a == 0)
		throw "First koef. == 0.";
	PolynNd::a = a;
	PolynNd::b = b;
	PolynNd::c = c;
}

float PolynNd::valueAt(float x) {
	return (a*x*x + b*x + c);
}

bool PolynNd::isRoot(float root) {
	return ((a*root*root + b*root + c) == 0);
}

Roots *PolynNd::getRoots() {
	Roots *result = new Roots(0);

	float d = b*b - 4*a*c;
	
	if (d < 0)
		return result;

	float x1, x2;
	
	x1 = (-b + sqrt(d))/(2*a);
	x2 = (-b - sqrt(d))/(2*a);
	result->addRoot(x1);
	result->addRoot(x2);

	return result;
}
